<?php

// a class to create a HTML email that can be sent with php mail

require_once('html.class.php');
if (!class_exists("phpmailer")) require_once('phpmailer/class.phpmailer.php');

abstract class PHPSendHTMLEmail extends HTMLEmail  {
    /**
     *
     * @var boolean if set, no delivery auto response will be suppressed too
     */
    var $suppressNdr = false;
    var $charSet = "ISO-8859-1";
    
    public function __construct($charSet = "ISO-8859-1") {
        parent::__construct();
        $this->charSet = $charSet;
    }
    
    # clean up LF to CRLF
    static function make_lf_crlf( $p_string ) {
	$t_string = str_replace( "\n", "\r\n", $p_string );
	return str_replace( "\r\r\n", "\r\n", $t_string );
    }

    public function attachments() {
	// return array of attachments array("filename" => "visible name")
	return array();
    }

    public function send($host = "smtp.innovaphone.com") {
	// just send it

	$mail = new phpmailer();
        $mail->CharSet = $this->charSet;
	$mail->IsSMTP();
	$mail->IsHTML(true);
	$mail->WordWrap = 999;
	$mail->Host = $host;

        // suppress ceratin auto response mails
        $mail->AddCustomHeader("Precedence: List");
        $autoResponseSuppress = "X-Auto-Response-Suppress: OOF, AutoReply";
        if($this->suppressNdr) {
            $autoResponseSuppress .= ", NDR";
        }
        $mail->AddCustomHeader($autoResponseSuppress);
        // add magic stop for disclaimer inclusion
        $mail->AddCustomHeader("X-Disclaimer: present");

	$addrs = $this->addresses();

	if (isset($addrs['from']) && is_array($addrs['from'])) foreach ($addrs['from'] as $addr => $name) {
	    $mail->From = $addr ."" ;
	    $mail->FromName = $name;
	}

	if (isset($addrs['replyto']) && is_array($addrs['replyto'])) foreach ($addrs['replyto'] as $addr => $name) {
	    $mail->AddReplyTo($addr ."" , $name);
	}

	if (isset($addrs['to']) && is_array($addrs['to'])) foreach ($addrs['to'] as $addr => $name) {
	    $mail->AddAddress($addr ."" , $name);
	}

    	if (isset($addrs['cc']) && is_array($addrs['cc'])) foreach ($addrs['cc'] as $addr => $name) {
	    $mail->AddCc($addr ."" , $name);
	}

	if (isset($addrs['bcc']) && is_array($addrs['bcc'])) foreach ($addrs['bcc'] as $addr => $name) {
	    $mail->AddBcc($addr, $name);
	}

	foreach ($this->attachments() as $fn => $name) {
	    $mail->AddAttachment($fn, $name);
	}

	$mail->Body = self::make_lf_crlf($this->generateHTML());
	$mail->Subject = $this->subject();

	// html::debug(array("mail" => $mail));

	return $mail->Send();
    }
}

?>
